"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.regexp.replace");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.for-each");

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _helperPluginUtils = require("@babel/helper-plugin-utils");

var _handler = _interopRequireDefault(require("./utils/handler"));

var _flowFiles = _interopRequireDefault(require("./utils/flowFiles"));

var _writeFiles = _interopRequireDefault(require("./utils/writeFiles"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (0, _helperPluginUtils.declare)(function (api, options) {
  api.assertVersion(7);

  _handler.default.initializeOptions(options);

  return {
    manipulateOptions: _handler.default.manipulateOptions,
    visitor: {
      ImportDeclaration: function ImportDeclaration(_ref, _ref2) {
        var value = _ref.node.source.value;
        var cwd = _ref2.cwd,
            filename = _ref2.filename;
        if (!/\.js\.flow$/.test(value)) return;

        var filePath = _path.default.resolve(filename, '..', value);

        var _handler$getFilePaths = _handler.default.getFilePaths(filePath, cwd),
            srcPath = _handler$getFilePaths.srcPath,
            destPath = _handler$getFilePaths.destPath;

        if (_flowFiles.default.fileExist(srcPath)) return;

        _flowFiles.default.add({
          srcPath: srcPath,
          destPath: destPath,
          filePath: filePath,
          babelConfig: {
            notInitialized: true
          }
        });
      }
    },
    post: function post(_ref3) {
      var _ref3$opts = _ref3.opts,
          cwd = _ref3$opts.cwd,
          filename = _ref3$opts.filename,
          parserOpts = _ref3$opts.parserOpts;
      var plugins = _handler.default.options.plugins;

      var _handler$getFilePaths2 = _handler.default.getFilePaths(filename, cwd),
          srcPath = _handler$getFilePaths2.srcPath,
          destPath = _handler$getFilePaths2.destPath;

      var babelConfig = {
        plugins: plugins,
        parserOpts: parserOpts
      };

      _flowFiles.default.store.forEach(function (flowFile) {
        if (flowFile.babelConfig.notInitialized) {
          delete flowFile.babelConfig.notInitialized;
          flowFile.babelConfig = babelConfig;

          _writeFiles.default.add(flowFile);
        }
      });

      var flowFilePath = filename.replace(/\.js$/, '.js.flow');
      var flowSrcPath = srcPath.replace(/\.js$/, '.js.flow');

      if (_fs.default.existsSync(flowFilePath)) {
        if (!_flowFiles.default.fileExist(flowSrcPath)) {
          var flowFile = {
            srcPath: flowSrcPath,
            destPath: destPath,
            filePath: flowFilePath,
            babelConfig: babelConfig
          };

          _flowFiles.default.add(flowFile);

          _writeFiles.default.add(flowFile);
        }

        return;
      }

      _writeFiles.default.add({
        srcPath: srcPath,
        destPath: destPath,
        babelConfig: babelConfig
      });
    }
  };
});

exports.default = _default;
module.exports = exports.default;